<?php
/**
 * Plugin Name: EDD Social Media Marketing
 * Plugin URI: https://around.io
 * Description: Around.io helps you to put your EDD store's social media marketing on Automation.Plan and promote your product listings and many more features.
 * Version: 1.0
 * Author: Natwar Maheshwari
 * License: GPLv2
 */

add_action('admin_menu','eddplugin_admin_actions');

function eddplugin_admin_actions(){

    //js file
    wp_register_script( 'edd_plugin_script', plugins_url('/edd-social-media-marketing.js', __FILE__), array('jquery'));
    /*wp_localize_script('edd_plugin_script', 'eddPluginScript', array(
        //'generateKey' => plugins_url('generate-around-key.php',__FILE__),
        'generateKey' => plugins_url('edd-social-media-marketing.php',__FILE__),
    ));*/
    wp_enqueue_script( 'edd_plugin_script' );

    add_menu_page('Around EDD Plugin','Social Media (EDD)','manage_options','eddsocialhome','eddplugin_admin',plugins_url('images/logo_mini.png',__FILE__),2);
}

function eddplugin_admin()
{
    //get around key for the user
    $site_url = get_site_url();

    ?>
    <div class="wrap">
        <style>
            #pluginBody {
                margin: 24px auto;
                height: 100%;
                font: 10px/16px sans-serif;
                background-color: rgba(0,0,0,0.05);
            }
            h2 {
                color: #1abc9c;
            }
            .unit p, ol, ul {
                line-height: 24px;
                font-size: 16px;
            }
            a {
                color: #1abc9c;
            }
            .unit {
                margin-bottom: 24px;
                font-size: 1.2em;
            }
            .unit h2 {
                font-size: 1.6em;
                line-height: 24px;
            }
            .unit h3 {
                font-size: 1.6em;
            }
            .unit ol li {
                padding-bottom: 16px;
            }
            .unit h3.key span {
                padding: 8px;
                background-color: #fff;
                border: 1px solid #1abc9c;
                border-radius: 4px;
            }
            .unit.marginBottom {
                margin-bottom: 48px;
            }
            .alnCenter {
                text-align: center;
            }

            .logo img {
                max-width: 100px;
            }
            #generate-key:hover {
                box-shadow: 0px 0px 4px -1px rgba(0,0,0,0.3);
            }
        </style>

        <div class="unit marginBottom alnCenter">
            <div class="logo">
                <img src="<?php echo plugins_url('images/aroundio-logo.png',__FILE__); ?>">
            </div>
        </div>

        <div class="unit marginBottom alnCenter">
            <h2>Congrats! You just installed EDD Social Media Marketing Plugin successfully!</h2>
        </div>

        <div class="unit marginBottom" id="generate-key-box">
            <h3 class="key">
                <input type="hidden" id="site-url" value="<?php echo $site_url; ?>">
                <input type="hidden" id="ajax-nonce" value="<?php echo wp_create_nonce( "generate-key" ); ?>">
                Generate Around Key: <input type="button" id="generate-key" value="Click to generate" style="cursor: pointer; font-weight: normal; font-size: 0.9em; padding: 8px; color: #fff; background: #1abc9c; border: 1px solid #1abc9c; border-radius: 4px;">
            </h3>
        </div>

        <div class="unit marginBottom" id="key-box" style="display: none;">
            <h3 class="key">
                Your Around.io key is: <span id="aroundKey"><?php //echo $resp_store->aroundKey; ?></span>
            </h3>
        </div>

        <div class="unit">
            <h3>
                Here's what you need to do next:
            </h3>
        </div>

        <div class="unit">
            <ol>
                <li>
                    Copy the Around.io key
                <li>
                    Sign up at <a href="https://app.around.io/#register" target="_blank">Around.io</a> (skip to the next step if you've already done this).
                </li>
                <li>
                    Paste your Around.io key and your EDD shop's URL in the respective fields when you sign up at Around.io.
                </li>
            </ol>
        </div>
        <div class="unit">
            <p>
                That's it. You will see all your products in your Around.io dashboard.
            </p>
        </div>
        <div class="unit marginBottom">
            <p>
                Need any help? Just send an email to <a href="mailto:hi@around.io">hi@around.io</a> and we'll help you get started right away.
            </p>
        </div>
    </div>

    <?php
}

$data = $_REQUEST;
//print_r($_REQUEST);

if (!empty($data['functionName']) && isset($data['functionName']))
{
    //echo "here";die;
    eddplugin_generate_key();
}

function eddplugin_generate_key()
{
    if (!defined('ABSPATH'))
    {
        echo 'error';
        exit();
    }

    add_action( 'wp_ajax_gen_key', 'my_action_function' );
    function my_action_function() {
        check_ajax_referer( 'generate-key', 'ajaxNonce' );
        wp_die();
    }


    if ($_POST['market'] != 'edd' || filter_var($_POST['siteurl'], FILTER_VALIDATE_URL) === false)
    {
        echo 'error';
        exit();
    }

    $request['request'] = array(
        'market' => $_POST['market'],
        'storeDomain' => $_POST['siteurl']
    );

    $appUrl  = "https://app.around.io/api/v2/store/generateAroundKey";

    $ch = curl_init();
//$header[] = 'Authorization: Bearer '.$_REQUEST['token'];
    $header[] = 'Content-Type:application/json';
    curl_setopt($ch, CURLOPT_URL, $appUrl);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($request));
    $resp_store = json_decode(curl_exec($ch));

    echo esc_attr($resp_store->aroundKey);
    die;
}

add_action('wp_ajax_gen_key','eddplugin_generate_key');

?>